/*
shflcomb.c Version 0.1.0 - Fischer Random Shuffle Permutation
Copyright (C) 2004  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <frshuf.h>

void knight(shuf,game)
shflfmt *shuf;
char *game;
   {
   char *p,*q,*r;
   p = (char *) game;
   q = (char *) p + 8;

   /* first open square for knight */
   while (p < q)
      {
      if (*p == '1') break;
      p++;
      } /* first open square for knight */
   *p++ = 'N';

   /* next knight */
   while (p < q)
      {
      if (*p == '1') break;
      p++;
      } /* next open square */
   *p = 'N';

   /* nth permutation where n = shuf->indx */
   /* WDTH is 2 << 4 */
   r = (char *) shuf->game + (shuf->indx << 4);
   strcpy(r,game);
   shuf->indx++;

   /* remove knights for next permutation */
   p = (char *) game;
   while (p < q)
      {
      if (*p == 'N') *p = '1';
      p++;
      } /* next knight square */
   *p = '\0';

   } /* knight */

void queen(shuf,game)
shflfmt *shuf;
char *game;
   {
   char *p,*q;
   p = (char *) game;
   q = (char *) p + 8;

   /* first open square for queen */
   while (p < q)
      {
      if (*p == '1') break;
      p++;
      } /* first open square for queen */
   *p = 'Q';
   knight(shuf,game);
   *p++ = '1';

   /* next queen */
   while (p < q)
      {
      if (*p == '1') break;
      p++;
      } /* next open square */
   *p = 'Q';
   knight(shuf,game);
   *p++ = '1';

   /* next queen */
   while (p < q)
      {
      if (*p == '1') break;
      p++;
      } /* next open square */
   *p = 'Q';
   knight(shuf,game);
   *p++ = '1';
   } /* queen */

void rghtrook(shuf,game)
shflfmt *shuf;
char *game;
   {
   char *p,*q;
   p = (char *) game;
   q = (char *) p + 8;

   /* first open square after king for right rook */
   while (p < q)
      {
      if (*p++ == 'K') break;
      } /* find king */

   while (p < q)
      {
      if (*p == '1') break;
      p++;
      } /* first open square for right rook */
   *p = 'R';
   queen(shuf,game);
   *p++ = '1';

   /* next right rook */
   while (p < q)
      {
      if (*p == '1') break;
      p++;
      } /* next open square */
   if (p >= q) return;
   *p = 'R';
   queen(shuf,game);
   *p++ = '1';

   /* next right rook */
   while (p < q)
      {
      if (*p == '1') break;
      p++;
      } /* next open square */
   if (p >= q) return;
   *p = 'R';
   queen(shuf,game);
   *p++ = '1';

   /* next right rook */
   while (p < q)
      {
      if (*p == '1') break;
      p++;
      } /* next open square */
   if (p >= q) return;
   *p = 'R';
   queen(shuf,game);
   *p++ = '1';

   return;
   } /* rghtrook */

void leftrook(shuf,game)
shflfmt *shuf;
char *game;
   {
   char *p,*q;
   p = (char *) game;
   q = (char *) p + 8;

   /* first open square for left rook */
   while (p < q)
      {
      if (*p == '1') break;
      p++;
      } /* first open square for left rook */
   *p = 'R';
   rghtrook(shuf,game);
   *p++ = '1';

   /* next left rook */
   while (p < q)
      {
      if (*p == 'K') return;
      if (*p == '1') break;
      p++;
      } /* next open square */
   *p = 'R';
   rghtrook(shuf,game);
   *p++ = '1';

   /* next left rook */
   while (p < q)
      {
      if (*p == 'K') return;
      if (*p == '1') break;
      p++;
      } /* next open square */
   *p = 'R';
   rghtrook(shuf,game);
   *p++ = '1';

   /* next left rook */
   while (p < q)
      {
      if (*p == 'K') return;
      if (*p == '1') break;
      p++;
      } /* next open square */
   *p = 'R';
   rghtrook(shuf,game);
   *p++ = '1';

   return;
   } /* leftrook */

void king(shuf,game)
shflfmt *shuf;
char *game;
   {
   char *p,*q;
   p = (char *) game;
   q = (char *) p + 8;

   /* first open square for left rook */
   while (p < q)
      {
      if (*p++ == '1') break;
      } /* first open square for left rook */

   /* next 4 open squares for king */
   /* allocate king */
   while (p < q)
      {
      if (*p == '1') break;
      p++;
      } /* next open square */
   *p = 'K';
   leftrook(shuf,game);
   *p++ = '1';

   /* allocate king */
   while (p < q)
      {
      if (*p == '1') break;
      p++;
      } /* next open square */
   *p = 'K';
   leftrook(shuf,game);
   *p++ = '1';

   /* allocate king */
   while (p < q)
      {
      if (*p == '1') break;
      p++;
      } /* next open square */
   *p = 'K';
   leftrook(shuf,game);
   *p++ = '1';

   /* allocate king */
   while (p < q)
      {
      if (*p == '1') break;
      p++;
      } /* next open square */
   *p = 'K';
   leftrook(shuf,game);
   *p++ = '1';
   } /* king */

void darkbish(shuf,game)
shflfmt *shuf;
char *game;
   {
   /* allocate dark bishop */
   *(game) = 'B';
   king(shuf,game);
   *(game) = '1';
   *(game+2) = 'B';
   king(shuf,game);
   *(game+2) = '1';
   *(game+4) = 'B';
   king(shuf,game);
   *(game+4) = '1';
   *(game+6) = 'B';
   king(shuf,game);
   *(game+6) = '1';
   } /* darkbish */

void shflcomb(shuf)
shflfmt *shuf;
   {
   char *p,*q;
   char game[8+8];

   /* first combo */
   shuf->indx = 0;

   /* initialize current game */
   p = (char *) game;
   q = (char *) p + 8;
   while (p < q) *p++ = '1';
   *p = '\0';

   /* allocate light bishop */
   p = (char *) game;
   *(p+1) = 'B';
   darkbish(shuf,game);
   *(p+1) = '1';
   *(p+3) = 'B';
   darkbish(shuf,game);
   *(p+3) = '1';
   *(p+5) = 'B';
   darkbish(shuf,game);
   *(p+5) = '1';
   *(p+7) = 'B';
   darkbish(shuf,game);
   } /* shflcomb */
